﻿/*
Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
For licensing, see LICENSE.html or http://ckeditor.com/license
*/

CKEDITOR.skins.add( 'kama', (function()
{
	var preload = [];

	if ( CKEDITOR.env.ie && CKEDITOR.env.version < 7 )
	{
		// For IE6, we need to preload some images, otherwhise they will be
		// downloaded several times (CSS background bug).
		preload.push( 'icons.png', 'images/sprites_ie6.png', 'images/dialog_sides.gif' );
	}

	return {
		preload		: preload,
		editor		: { css : [ 'editor.css' ] },
		dialog		: { css : [ 'dialog.css' ] },
		templates	: { css : [ 'templates.css' ] },
		margins		: [ 0, 0, 0, 0 ],
		init : function( editor )
		{
			CKEDITOR.tools.extend( editor,
			{
				uiColor: null,

				getUiColor : function() {
					return this.uiColor;
				},

				setUiColor : function( color )
				{
					var editor = this,
						uiStyle = this.container.getDocument().getBody().append('style'),
						cssId = '#cke_' + editor.name.replace('.', '\\.'),
						cssSelectors =
						[
							cssId + " .cke_wrapper",
							cssId + "_dialog .cke_dialog_contents",
							cssId + "_dialog a.cke_dialog_tab",
							cssId + "_dialog .cke_dialog_footer"
						],
						cssSrc = cssSelectors.join( ',' )
							+ "{ background-color: ${color} !important; }";
					
					uiStyle.setAttribute("type", "text/css");
					
					return (this.setUiColor = function( color )
					{
						var css = cssSrc.replace( '${color}', color );
						editor.uiColor = color;
						if ( CKEDITOR.env.ie )
							uiStyle.$.styleSheet.cssText = css;
						else
							uiStyle.setHtml( css );
					})( color );
				}
			});

			// Apply UI color if specified in config.
			if ( editor.config.uiColor )
			{
				// Delay to gain access to container element.
				CKEDITOR.tools.setTimeout( function()
					{
						if ( !this.container )
							CKEDITOR.tools.setTimeout( arguments.callee, 1000, this );
						else
							this.setUiColor( this.config.uiColor );
					}, 1000, editor);
			}
		}
	};
})() );

if ( CKEDITOR.dialog )
{
	CKEDITOR.dialog.on( 'resize', function( evt )
		{
			var data = evt.data,
				width = data.width,
				height = data.height,
				dialog = data.dialog,
				standardsMode = !CKEDITOR.env.quirks;

			if ( data.skin != 'kama' )
				return;

			dialog.parts.contents.setStyles(
				{
					width : width + 'px',
					height : height + 'px'
				});

			if ( !CKEDITOR.env.ie )
				return;

			// Fix the size of the elements which have flexible lengths.
			setTimeout( function()
				{
					var content = dialog.parts.contents,
						body = content.getParent(),
						innerDialog = body.getParent();

					// tc
					var el = innerDialog.getChild( 2 );
					el.setStyle( 'width', ( body.$.offsetWidth ) + 'px' );

					// bc
					el = innerDialog.getChild( 7 );
					el.setStyle( 'width', ( body.$.offsetWidth - 28 ) + 'px' );

					// ml
					el = innerDialog.getChild( 4 );
					el.setStyle( 'height', ( body.$.offsetHeight - 31 - 14 ) + 'px' );

					// mr
					el = innerDialog.getChild( 5 );
					el.setStyle( 'height', ( body.$.offsetHeight - 31 - 14 ) + 'px' );
				},
				100 );
		});
}
